	; Use PnP BIOS to power off.
	; returns 0 if okay, 128 or more if error

	org 100h

start:	sub sp,10h	; just in case
	mov ah,9
	mov dx,hellomsg
	int 21h
	mov ax,0f000h
next:	mov es,ax
	cmp word [es:0], '$P'	; $ is first byte
	jnz nfound
	cmp word [es:2], 'nP'	; $PnP
	jz found
nfound:	inc ax
	cmp ax,0fffeh
	jnz next
	mov ah,9
	mov dx,nopnpbios
	int 21h		; show string
	mov ax,4cffh	; errorlevel 255
	int 21h		; exit

found:	mov ax,[es:1bh]	; real mode data segment
	les bx,[es:0dh]	; call far real mode entry point
	mov [cs:handler+2],es
	mov [cs:handler],bx
	;
	mov ds,ax	; segment for BIOS
	mov es,ax	; segment for BIOS
	;
	mov ax,cs	; writeable segment for PnP BIOS
	add ax,1000h	; yes, this is evil if somebody LOADHIGHed us...
	push ax		; scratch segment
	mov ax,41h	; "power off" message
	push ax		; message
	mov ax,4	; "send message"
	push ax		; command
	call far [cs:handler]	; needs up to 1024 bytes of stack
	pop bx
	pop bx
	pop bx
	;
	push ax		; status: 0 = okay, most errors above 80h
	mov ax,cs
	mov ds,ax
	mov es,ax
	mov ah,9
	mov dx,donemsg
	int 21h		; show string
	pop ax
	;
	push ax
	or al,al
	jnz nokay
	mov ah,9
	mov dx,okaystatus
	int 21h
	jmp short shown
nokay:	test al,80h
	jz nerr
	mov ah,9
	mov dx,warnstatus
	int 21h
	jmp short shown
nerr:	mov ah,9
	mov dx,errstatus
	int 21h
shown:	pop ax
	;
	mov ah,4ch
	int 21h		; exit

handler		dd 0	; far pointer to real mode entry point

hellomsg	db "Trying to power off system with PnP BIOS / DMI call"
		db 13,10,"$"
nopnpbios	db "No PnP BIOS found",13,10,"$"
donemsg		db "PnP BIOS command 4, function 0x41 sent (power off)."
		db 13,10,"$"
okaystatus	db "Okay.",13,10,"$"
warnstatus	db "See errorlevel for status.",13,10,"$"
errstatus	db "See errorlevel for error code,",13,10
		db "e.g. 130 means 'not supported'.",13,10,"$"
